library Big;//Version for 'pub'
import 'dart:mirrors'; 
import 'dart:js';

//Library Scoped methods and attributes
String typeof(var obj){
  return((obj is BigNumber_Dart)?'BigNumber_Dart':reflect(obj).type.reflectedType.toString());
  }//end Dart version of typeof

class BigNumber_Dart{
  //Static methods and attributes
  static JsObject configObj=new JsObject(context['BigNumber'],['0']);
  static Map config([Map arguments=null]){
    JsObject configCurrent=null;
    Map m=new Map();
    try{
      configCurrent=configObj.callMethod('config',[arguments]);
    }catch(ee){
      String message='Big:BigNumber_Dart:: Your version of bignumber.js has not been modified for the Dart Language!,\n'+
          'Add the code line P[\'config\']=BigNumber[\'config\']; after the config function in bignumber.js!\n'+
          'This will enable calls to BigNumber.config() from Dart.';
      throw message;//Then halt!
    }finally{
    }//end try
    m['DECIMAL_PLACES']=configCurrent['DECIMAL_PLACES'];
    m['ERRORS']=configCurrent['ERRORS'];
    m['EXPONENTIAL_AT']=configCurrent['EXPONENTIAL_AT'];
    m['RANGE']=configCurrent['RANGE'];
    m['ROUNDING_MODE']=configCurrent['ROUNDING_MODE'];
    return (m);
  }//end config
  static String test(){
    String str='';
    print('Testing BigNumber_Dart constructor...............START..................');
    Map m = BigNumber_Dart.config();//test that call to config is enabled!
    BigNumber_Dart bigTest=null;
    str+='config tested:'+m.toString();
  try{
    bigTest = new BigNumber_Dart('-5032485723458348569331745.33434346346912144534543');
    str+='\n'+bigTest.toStringInstance();
    str+='\nabs(): '+bigTest.abs().toS();
    str+='\nceil(): '+bigTest.ceil().toS();
    str+='\ncmp(): '+bigTest.cmp(989897).toString();
    str+='\ndiv(): '+bigTest.div(bigTest).toS();
    str+='\ndiv(): '+bigTest.div(54444).toS();
    str+='\nfloor(): '+bigTest.floor().toS();
    str+='\nminus(): '+bigTest.minus(bigTest).toS();
    str+='\nneg(): '+bigTest.neg().toS();
    str+='\nplus(): '+bigTest.plus(bigTest).toS();
    str+='\npow(): '+bigTest.pow(2).toS();
    str+='\nround(): '+bigTest.round(4).toS();
    str+='\nsqrt(): '+new BigNumber_Dart(64*64).sqrt().toS();
    str+='\ntimes(): '+bigTest.times(bigTest).toS();
    str+='\ntoExponential(): '+bigTest.toExponential();
    str+='\ntoFixed(10): '+bigTest.toFixed(10);
    str+='\nequals: double: 454.55? ${bigTest.equals(454.55)}';
    str+='\ngreaterThan: double: 454.55? ${bigTest.greaterThan(454.55)}';
    str+='\ngreaterThanOrEqualTo: double: 454.55? ${bigTest.greaterThanOrEqualTo(454.55)}';
    str+='\nlessThan: double: 454.55? ${bigTest.lessThan(454.55)}';
    str+='\nlessThanOrEqualTo: double: 454.55? ${bigTest.lessThanOrEqualTo(454.55)}';
    List toFraction = bigTest.toFraction();
    str+='\ntoFraction(): ';
    toFraction.forEach((E){str+='\n'+E.toString();});
    str+='\ntoPrecision(60): '+bigTest.toPrecision(60);
    str+='\ntoString(base:16): '+bigTest.toString(16);
  }catch(ee){
    str=ee.toString();
  }finally{}
    print(str);
    print('Testing BigNumber_Dart constructor...............END....................');
    return(str);
  }//end test
  /********************************END TEST*****************************************************/
  //Instance methods and attributes
  String sourceType='unknown';
  JsObject JsObject_BigNumber = null;
  //Main Constructor
  BigNumber_Dart(var value, [int base=null]) {
//    log('BigNumber_Dart::Constructor: START');
    sourceType = typeof(value);
    JsObject_BigNumber=new JsObject(context['BigNumber'], [value, base]);
//    log('BigNumber_Dart::Constructor: END');
  }//end constructor
  // PROTOTYPE/INSTANCE METHODS
  BigNumber_Dart abs(){return absoluteValue();}
  BigNumber_Dart absoluteValue(){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('absoluteValue')));}
  BigNumber_Dart ceil(){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('ceil')));}
  int cmp(var y, [int base=null]){return(comparedTo(y, base));}
  int comparedTo(var y, [int base=null]) {return(JsObject_BigNumber.callMethod('comparedTo',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base]));}
  BigNumber_Dart div(var y, [int base=null]){return(dividedBy(y, base));}
  BigNumber_Dart dividedBy(var y, [int base=null]){
    return(new BigNumber_Dart(JsObject_BigNumber.callMethod('dividedBy',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base])));
  }//end method
  bool eq(var n, [int base=null]){return(equals(n, base));}
  bool equals(var n, [int base=null]){return(JsObject_BigNumber.callMethod('equals',[(n is BigNumber_Dart)?n.JsObject_BigNumber:n, base]));}
  bool gt(var n, [int base=null]){return(greaterThan(n, base));}
  bool greaterThan(var n, [int base=null]){return(JsObject_BigNumber.callMethod('greaterThan',[(n is BigNumber_Dart)?n.JsObject_BigNumber:n, base]));}
  bool gte(var n, [int base=null]){return(greaterThanOrEqualTo(n, base));}
  bool greaterThanOrEqualTo(
       var n, [int base=null]){return(JsObject_BigNumber.callMethod('greaterThanOrEqualTo',[(n is BigNumber_Dart)?n.JsObject_BigNumber:n, base]));}
  bool isF(){return(isFinite());}
  bool isFinite(){return(JsObject_BigNumber.callMethod('isFinite'));}
  bool isNaN(){return(JsObject_BigNumber.callMethod('isNan'));}
  bool isNeg(){return(isNegative());} 
  bool isNegative(){return(JsObject_BigNumber.callMethod('isNegative'));}
  bool isZ(){return(isZero());}
  bool isZero(){return(JsObject_BigNumber.callMethod('isZero'));}
  bool lt(var n, [int base=null]){return(lessThan(n, base));}
  bool lessThan(var n, [int base=null]){return(JsObject_BigNumber.callMethod('lessThan',[(n is BigNumber_Dart)?n.JsObject_BigNumber:n, base]));}
  bool lte(var n, [int base=null]){return(lessThanOrEqualTo(n, base));}
  bool lessThanOrEqualTo(
       var n, [int base=null]) {return(JsObject_BigNumber.callMethod('lessThanOrEqualTo',[(n is BigNumber_Dart)?n.JsObject_BigNumber:n, base]));}
  BigNumber_Dart floor(){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('floor')));}
  BigNumber_Dart minus(var y, [int base=null]) {return(new BigNumber_Dart(JsObject_BigNumber.callMethod('minus',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base])));}
  BigNumber_Dart mod(var y, [int base=null]){return(modulo(y, base));}
  BigNumber_Dart modulo(var y, [int base=null]) {return(new BigNumber_Dart(JsObject_BigNumber.callMethod('modulo',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base])));}
  BigNumber_Dart neg() {return(negated());}
  BigNumber_Dart negated(){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('negated')));}
  BigNumber_Dart plus(var y, [int base=null]){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('plus',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base])));}
  BigNumber_Dart pow(int e){return(toPower(e));}
  BigNumber_Dart toPower(int e) {return(new BigNumber_Dart(JsObject_BigNumber.callMethod('toPower',[e])));}
  BigNumber_Dart round(decimalPlaces, [int roundingMode=null]){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('round',[decimalPlaces,roundingMode])));}
  BigNumber_Dart sqrt(){return(squareRoot());}
  BigNumber_Dart squareRoot(){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('squareRoot')));}
  BigNumber_Dart times(var y, [int base=null]){return(new BigNumber_Dart(JsObject_BigNumber.callMethod('times',[(y is BigNumber_Dart)?y.JsObject_BigNumber:y, base])));}
  String toE([int decimal_places=null]){return(toExponential(decimal_places));}
  String toExponential([int decimal_places=null]){return(JsObject_BigNumber.callMethod('toExponential',[decimal_places]));}
  String toF([int decimal_places=null] ){return(toFixed(decimal_places));}
  String toFixed([int decimal_places=null]){return(JsObject_BigNumber.callMethod('toFixed',[decimal_places]));}
  List toFr([var maxDenominator=null]){return(toFraction(maxDenominator));}
  List toFraction([var maxDenominator=null]){return(JsObject_BigNumber.callMethod('toFraction',[maxDenominator]));}
  String toP([int significant_figures=null]){return(toPrecision(significant_figures));}
  String toPrecision([int significant_figures=null]){return(JsObject_BigNumber.callMethod('toPrecision',[significant_figures]));}
  String toS([int base=null]){return(this.toString(base));}
  String toString([int base=null]){return(JsObject_BigNumber.callMethod('toString',[base]));}
  String valueOf(){return(JsObject_BigNumber.callMethod('toString'));}

  String toStringInstance(){//JsObject_BigNumber
    String str='';
    str+='BigNumber_Dart::toStringInstance: type: '+sourceType+', Sign: '+JsObject_BigNumber['s'].toString()+', Exponent: '
        +JsObject_BigNumber['e'].toString()+',\n component:[';
    JsObject_BigNumber['c'].forEach((E){str+=' '+E.toString();});
    str+=' ]';
    str+=',\n String: toString['+toString()+']';
    str+=',\n toFixed['+toF()+']';
    str+='\n abs:'+abs().toS();
    return(str);
  }//end method
}//end class